

#ifndef _ICONVIEW_HH_
#define _ICONVIEW_HH_

#include <qwidget.h>
#include <qevent.h>
#include <qscrbar.h>
#include <qpainter.h>
#include <qdir.h> 
#include <qlined.h>

#include "menus.hh"
#include "icon.hh"
#include "icondesk.hh"

class DirectoryBar ;
class QSlider ;
class QMultiLineEdit ;
class QStrList ;
class Sfm ;

class IconView : public QWidget {

  Q_OBJECT ;


  Sfm *app ;

  QDir currentDir ;
  IconDesk *desk ;

  MainMenuBar *mb ;
  
  DirectoryBar *db ;
  QWidget *controls ;
  QMultiLineEdit *infobox ;

  QScrollBar *hscrBar ;
  QScrollBar *vscrBar ;
  QSlider *scaler ;

  QWidget *rootDesk ;
  
  int heightOffset ; // how much space does db take up?
  
protected:

  // enum needType { zicon = 1 , openaction = 2 , dragdropaction = 3 } ;
  void paintEvent (QPaintEvent *pe) ;
  void resizeEvent (QResizeEvent *) ;
  // void loadRules () ;
  // char *matchToRules (QFileInfo &fi, needType) ;
  // void rescan () { } 

public:
  
  IconView (const QDir &dir,Sfm *parent) ;
  IconView (const char *c, Sfm *parent) ;

  QWidget *getRootDesk () const { return rootDesk ; } 
  void dragPointAt (const QPoint &p) ;
  void dragDropRelease (const QPoint &, const QList<Icon> &) ;

  void refresh () ;

 public slots:
 void openIcon (const QList<Icon> *, QMouseEvent *me = 0) ;
  void openIcon () ;
  void openAppl () ;
  void close () ;
  void changeDir (const QDir &dir) ;
  void changeDir (const char *) ;
  QString getCurrentDir () const { return currentDir.absPath() ; }
  void deskResized (int, int) ;

  void dragDropHighlight (WId, const QPoint &, const QList<DeskIcon> &icList) ;
  void drag_drop_happened (WId, const QPoint &pos, const QList<DeskIcon> &icList) ;

  //  void iconClicked (Icon *, QMouseEvent *) ;

  //  const char *suggestZic (const char *) ;
  // bool isDragDroppable (const QFile *) ;
} ;

#endif // _ICONVIEW_HH_
